!     INCLUDE FILE EM DATA BDB
! - increased the size of MAXTVERT to 200 - 11/12 - kmf
MODULE INPPARAMS
USE DBNULL
IMPLICIT NONE
INTEGER, PARAMETER :: MAXFLDS=100             !MAX FLDS IN DATABASE
INTEGER, PARAMETER :: MAXTIMES=90             !MAXIMUM WINDOW TIMES
INTEGER, PARAMETER :: MAXHARR=372             !MAXIMUM NUMERIC HEADER VALUES
REAL,DIMENSION(MAXFLDS) :: ZDATA,ZMIN,ZMAX    !ARRAY FOR 1 RECORD AND MAX MINS FOR ALL  
REAL, DIMENSION(MAXHARR) :: HARR = 1.0E-30    !ARRAY FOR NUMERIC HEADER VALUES
LOGICAL(KIND=1) :: LSORT                      !FLAG IF DATABASE IS SORTED
LOGICAL(KIND=1), DIMENSION(MAXFLDS) :: LTYPE  !ARRAY OF FLAGS FOR NUMERIC/CHARACTER VARIABLES
CHARACTER(LEN=12), DIMENSION(MAXFLDS) :: LABEL!ARRAY OF FIELD LABELS IN DATABASE
CHARACTER (LEN=40), DIMENSION (14) :: HSTR = ''!ARRAY OF TEXT FIELDS IN HEADER
INTEGER :: LUHPRT                             !HANDLE FOR PRT FILE
INTEGER :: LUHOUT                             !HANDLE FOR OUTPUT FILE
INTEGER :: NFLD                               !NUMBER OF FIELDS IN DATABASE <=MAXFLDS
INTEGER :: NPTS                               !NUMBER OF POINTS IN DATABASE
INTEGER :: NCHAN                              !NUMBER OF WINDOWS IN DATABASE <= MAXTIMES
INTEGER :: NCHANOUT                           !NUMBER OF WINDOWS TO OUTPUT
INTEGER :: LOCX                               !DATABASE FIELD CONTAINING X  
INTEGER :: LOCY                               !DATABASE FIELD CONTAINING Y
REAL :: TDELAY                                !TIME FROM START OF TURN OFF TO TIME ZERO IN mSec
REAL :: RXDELAY                               !Rx COIL DELAY IN mSec
LOGICAL :: LCRONE                             ! FLAG FOR CRONE DATABASE CH1=PP
LOGICAL :: LSMART                             ! FLAG FOR SMARTEM DATABASE INCLUDES GAIN AND LOOP NUMNBER
LOGICAL :: LTESLA                             ! FLAG FOR TESLA SIROTEM DATABASE ALLOWS FOR VARIATIONS IN RAMP AND DELAY TIME
LOGICAL :: LZONGE                             ! FLAG FOR ZONGE DATABASE ALLOWS FOR VARIATIONS IN DELAY TIME
LOGICAL :: LNEWDBF                            ! FLAG FOR NEW DATABASE FORMAT WITH >4 POINTS IN TX LOOP
LOGICAL :: LAMIRA                             ! FLAG FOR AMIRA INPUT FILE.
LOGICAL :: LWMC                               ! FLAG FOR WMC FORMAT FILE

REAL, DIMENSION(MAXTIMES) :: WTIME            ! ARRAY FOR WINDOW TIMES
                !!!!!! - changed from 10 less than max - not thouroughly checked for consequences
INTEGER, PARAMETER :: NEUNITS = 11
CHARACTER(LEN=8), DIMENSION(NEUNITS), PARAMETER :: EUNITS = (/'uV      ','uV/A    ', &
 &'nT/Sec  ','nV/Am2  ','ppm     ','pT/A    ','nT      ','pT      ','fT      ','pV/Am4  ','pVmS/Am4'/)

INTEGER, PARAMETER :: NSURVEYS = 10
CHARACTER(LEN=17), DIMENSION(NSURVEYS), PARAMETER :: SURVEYS = (/'IN LOOP          ', &
        &'FIXED LOOP       ','SLINGRAM         ','DOWN HOLE        ','COINCIDENT LOOP  ','FIGURE 8 LOOP   ', &
        &'DUAL LOOP        ','SINGLE LOOP      ','INPUT AEM SQARWAV','INPUT AEM HALFSIN'/)
!
!     SET NORMAL FIELDS FOR EM DATABASE
!
INTEGER, PARAMETER :: ILINE=1                     !LINE
INTEGER, PARAMETER :: ISTAT=2                     !STATION  
INTEGER, PARAMETER :: IEAST=3                     !EASTING  
INTEGER, PARAMETER :: INRTH=4                     !NORTHING
INTEGER, PARAMETER :: IELEV=5                     !ELEVATION  
INTEGER, PARAMETER :: IANG=6                      !HOLE ANGLE = AZIMUTH * 100 + ABS(DIP)
INTEGER, PARAMETER :: ICOMP=7                     !COMPONENT 1=X/U 2=Y/V 3=Z/A 10=TOTAL FIELD
INTEGER, PARAMETER :: ICURR=8                     !CURRENT
INTEGER, PARAMETER :: MAXTXVER=200                ! MAX NUMBER OF VERTICES IN Tx LOOP  

INTERFACE LNULL
  LOGICAL FUNCTION LNULL(Z1,Z2,Z3,Z4,Z5)        ! DETERMINES WHETHER A FIELD VALUE IS NULL OR NOT
  REAL, INTENT(IN) :: Z1
  REAL, OPTIONAL, INTENT(IN) :: Z2
  REAL, OPTIONAL, INTENT(IN) :: Z3
  REAL, OPTIONAL, INTENT(IN) :: Z4
  REAL, OPTIONAL, INTENT(IN) :: Z5
  END FUNCTION LNULL
END INTERFACE

END MODULE






